;------------------------------------------------------------------------------
;  :	PDM.asm 
; :	   ATtiny2313,     
;				  (  - ).
;				        INT0
;				.     -   PB7.
;
;				  (..     100  
;				  )     USART  
;				  ( ,   ..).  : 8 , 
;				2 -,  - 250 /)
;
;				       
;				.
;
;   :
;				   : 0 - 100%   1%
;				     -  300 
;				 :  5V.
; :	ATtiny2313
;  : 16
; :		3.7.5
;
; :		 .., ku_@mail.ru
;
;  .., 2011
;------------------------------------------------------------------------------
.include "tn2313def.inc"
.list

.def	temp 	= R16				;  
.def	lev		= R17				;   
.def	err		= R18				;   
.def	a		= R19				;      
.def	bout	= R20				;      B

.equ	max		= 100				; ""    0  max
.equ	maxD2	= 50				;  


		rjmp RESET 					; Reset Handler
		rjmp INT_0 					; External Interrupt0 Handler
;------------------------------------------------------------------------------
;          ( 
; ).        ,  
;            
;        .
;  :
;    (err),    ,   
;   (a).       (maxD2 = 50).
;    ,  -    (  )
;        ,   - .
;             
;  .
;------------------------------------------------------------------------------
INT_0:	cbi		PORTB, 7			;    
		
		sbis	UCSRA,RXC			;    USART   ,  lev
		rjmp	Calc				;  
		in		lev, UDR			;      .

Calc:	mov		a, lev				;       
		add		a, err				;       a = lev+err
		brvs	HiSig				;  a > 127,    .
									;      HiSig.   
									;      < maxD2 (!)
		cpi		a, maxD2			;     "a"   
		brge	HiSig				; 
LoSig:	andi	bout, 0b01111111	;     0
		mov		err, a				; ..   7-  bout   (. ), 
		rjmp	GoOn				;    err = a - 0
HiSig:	ori		bout, 0b10000000	;  1  7-  bout.  err = a - max,
		mov		err, a				; ..  a > max,    "" (err > 0),
		subi	err, max			;   maxD2 < a < max,  "" (err < 0)
GoOn:	out		PORTB, bout			;   "Enable"
Exit:	reti
;------------------------------------------------------------------------------
;      
;------------------------------------------------------------------------------
Reset:	ldi		temp, RAMEND		;   
		out		SPL, temp

VarInit:	;  
		clr 	lev
		clr		err
		clr 	bout
PortsInit:	;   /
		ldi		temp, 0xFF			;   B -  .
		out		DDRB, temp
		out		PORTB, bout
									
		ldi		temp, 0b00000000	;  D -  
		out		DDRD, temp
		ldi		temp, 0b01111111	;   
		out		PORTD, temp

UARTInit:	;  USART
		ldi		temp, 3 
		out		UBRRL, temp
		clr		temp 
		out		UBRRH, temp			; UBRR = 3 -  16  - 250 /

		out		UCSRA, temp

		ldi 	temp, (1<<RXEN)
		out		UCSRB, temp			;  
 
		ldi		temp, (1<<UCSZ0)|(1<<UCSZ1)|(1<<USBS)
		out		UCSRC, temp			;   - 8   2 -
ExtIntInit:	;    
		ldi		temp, (1<<ISC01)|(1<<ISC11)
		out		MCUCR, temp			;   -  
		ldi		temp, (1<<INT0)|(1<<INT1)
		out		GIMSK, temp			;    INT0  INT1
		sei
Start:		;  
		rjmp	Start
;------------------------------------------------------------------------------

